(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;
var Random = Package.random.Random;
var Router = Package['iron:router'].Router;
var RouteController = Package['iron:router'].RouteController;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var Accounts = Package['accounts-base'].Accounts;
var check = Package.check.check;
var Match = Package.check.Match;
var SHA256 = Package.sha.SHA256;
var Email = Package.email.Email;
var Iron = Package['iron:core'].Iron;

(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/accounts-email-token/token_common.js                                                               //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
Accounts.emailToken = {};                                                                                      // 1
                                                                                                               // 2
Accounts.emailToken._hashToken = function (token) {                                                            // 3
  return {                                                                                                     // 4
    digest: SHA256(token),                                                                                     // 5
    algorithm: "sha-256"                                                                                       // 6
  };                                                                                                           // 7
};                                                                                                             // 8
                                                                                                               // 9
var enabled = false;                                                                                           // 10
                                                                                                               // 11
Accounts.emailToken.enable = function (accountsUi) {                                                           // 12
  enabled = true;                                                                                              // 13
  if (Meteor.isClient) {                                                                                       // 14
    accountsUi.registerService("emailToken", "an Email + Token");                                              // 15
  }                                                                                                            // 16
};                                                                                                             // 17
                                                                                                               // 18
Accounts.emailToken.disable = function (accountsUi) {                                                          // 19
  enabled = false;                                                                                             // 20
  if (Meteor.isClient) {                                                                                       // 21
    accountsUi.deregisterService("emailToken");                                                                // 22
  }                                                                                                            // 23
};                                                                                                             // 24
                                                                                                               // 25
Accounts.emailToken.isEnabled = function () {                                                                  // 26
  return enabled;                                                                                              // 27
};                                                                                                             // 28
                                                                                                               // 29
Router.route("/_emailToken/:_email/:_token", function () {                                                     // 30
  this.render("Loading");                                                                                      // 31
  var that = this;                                                                                             // 32
  Meteor.loginWithEmailToken(this.params._email, this.params._token, function (err) {                          // 33
    if (err) {                                                                                                 // 34
      that.render("_emailTokenError", {                                                                        // 35
        data: function () {                                                                                    // 36
          return {                                                                                             // 37
            error: err                                                                                         // 38
          };                                                                                                   // 39
        }                                                                                                      // 40
      });                                                                                                      // 41
    } else {                                                                                                   // 42
      Router.go("/");                                                                                          // 43
    }                                                                                                          // 44
  });                                                                                                          // 45
});                                                                                                            // 46
                                                                                                               // 47
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/accounts-email-token/token_server.js                                                               //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                      // 1
                                                                                                               // 2
var cleanupExpiredTokens = function() {                                                                        // 3
  while (0 < Meteor.users.update(                                                                              // 4
      {"identities.service.emailToken.tokens.createdAt": {$lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)}},   // 5
      {$pull: {                                                                                                // 6
        "identities.$.service.emailToken.tokens": {                                                            // 7
          createdAt: {$lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)}}}},                                     // 8
    { multi: true }));                                                                                         // 9
};                                                                                                             // 10
                                                                                                               // 11
Meteor.startup(cleanupExpiredTokens);                                                                          // 12
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                      // 13
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                        // 14
                                                                                                               // 15
var checkToken = function (tokens, token) {                                                                    // 16
  var found = false;                                                                                           // 17
  tokens.forEach(function (userToken) {                                                                        // 18
    if((userToken.algorithm === token.algorithm) &&                                                            // 19
       (userToken.digest === token.digest)) {                                                                  // 20
      found = true;                                                                                            // 21
    }                                                                                                          // 22
  });                                                                                                          // 23
                                                                                                               // 24
  return found;                                                                                                // 25
};                                                                                                             // 26
                                                                                                               // 27
// The name of the email package to use. It refers to a variable named in the global scope.                    // 28
var EMAIL_PACKAGE= "Email";                                                                                    // 29
                                                                                                               // 30
Accounts.emailToken.setEmailPackage = function (packageName) {                                                 // 31
  EMAIL_PACKAGE = packageName;                                                                                 // 32
};                                                                                                             // 33
                                                                                                               // 34
var Crypto = Npm.require("crypto");                                                                            // 35
                                                                                                               // 36
// Handler to login with a token.                                                                              // 37
Accounts.registerLoginHandler("emailToken", function (options) {                                               // 38
  if (!options.emailToken)                                                                                     // 39
    return undefined; // don't handle                                                                          // 40
                                                                                                               // 41
  options = options.emailToken;                                                                                // 42
  check(options, {                                                                                             // 43
    email: String,                                                                                             // 44
    token: String                                                                                              // 45
  });                                                                                                          // 46
                                                                                                               // 47
  var identityId = Crypto.createHash("sha256")                                                                 // 48
      .update("emailToken" + ":" + options.email).digest("hex");                                               // 49
  var user = Meteor.users.findOne({"identities.id": identityId},                                               // 50
                                  {fields: {"identities.$": 1}});                                              // 51
                                                                                                               // 52
  if (!user) {                                                                                                 // 53
    console.error("User not found:", options.email);                                                           // 54
    return {                                                                                                   // 55
      error: new Meteor.Error(403, "User not found")                                                           // 56
    };                                                                                                         // 57
  }                                                                                                            // 58
                                                                                                               // 59
  var identity = user.identities[0];                                                                           // 60
                                                                                                               // 61
  if (!identity.service.emailToken.tokens) {                                                                   // 62
    console.error("User has no token set:", options.email);                                                    // 63
    return {                                                                                                   // 64
      error: new Meteor.Error(403, "User has no token set")                                                    // 65
    };                                                                                                         // 66
  }                                                                                                            // 67
                                                                                                               // 68
  var token = Accounts.emailToken._hashToken(options.token.trim());                                            // 69
  var found = checkToken(identity.service.emailToken.tokens, token);                                           // 70
                                                                                                               // 71
  if (!found) {                                                                                                // 72
    console.error("Token not found:", identity);                                                               // 73
    return {                                                                                                   // 74
      error: new Meteor.Error(403, "Invalid authentication code")                                              // 75
    };                                                                                                         // 76
  }                                                                                                            // 77
                                                                                                               // 78
  Meteor.users.update({"identities.id": identityId},                                                           // 79
                      {$pull: {"identities.$.service.emailToken.tokens": token}});                             // 80
  return {                                                                                                     // 81
    userId: user._id                                                                                           // 82
  };                                                                                                           // 83
});                                                                                                            // 84
                                                                                                               // 85
var Url = Npm.require("url");                                                                                  // 86
                                                                                                               // 87
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                // 88
var HOSTNAME = ROOT_URL.hostname;                                                                              // 89
                                                                                                               // 90
var makeTokenUrl = function (email, token) {                                                                   // 91
  return process.env.ROOT_URL + "/_emailToken/" + encodeURIComponent(email) + "/" + encodeURIComponent(token); // 92
};                                                                                                             // 93
                                                                                                               // 94
///                                                                                                            // 95
/// EMAIL VERIFICATION                                                                                         // 96
///                                                                                                            // 97
var sendTokenEmail = function (email, token) {                                                                 // 98
  var options = {                                                                                              // 99
    to:  email,                                                                                                // 100
    from: HOSTNAME + " <no-reply@" + HOSTNAME + ">",                                                           // 101
    subject: "Log in to " + HOSTNAME,                                                                          // 102
    text: "To log in to " + HOSTNAME + ", click on the following link:\n\n" +                                  // 103
          makeTokenUrl(email, token) + "\n\n" +                                                                // 104
          "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" +        // 105
          token + "\n\n" +                                                                                     // 106
          "You are receiving this because someone (hopefully you) requested to log in to " +                   // 107
          HOSTNAME + " with your email address. If you did not request to log into " + HOSTNAME +              // 108
          ", you may ignore this message.\n\n" +                                                               // 109
          "This information will expire in 15 minutes.\n"                                                      // 110
  };                                                                                                           // 111
                                                                                                               // 112
  global[EMAIL_PACKAGE].send(options);                                                                         // 113
};                                                                                                             // 114
                                                                                                               // 115
///                                                                                                            // 116
/// CREATING USERS                                                                                             // 117
///                                                                                                            // 118
// returns the user id                                                                                         // 119
var createAndEmailTokenForUser = function (email) {                                                            // 120
  check(email, String);                                                                                        // 121
  var atIndex = email.indexOf("@");                                                                            // 122
  if (atIndex === -1) {                                                                                        // 123
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                        // 124
  }                                                                                                            // 125
                                                                                                               // 126
  var identityId = Crypto.createHash("sha256")                                                                 // 127
      .update("emailToken" + ":" + email).digest("hex");                                                       // 128
  var user = Meteor.users.findOne({"identities.id": identityId},                                               // 129
                                  {fields: {"identities.$": 1}});                                              // 130
  var userId;                                                                                                  // 131
                                                                                                               // 132
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                         // 133
  var token = Random.id(12);                                                                                   // 134
  var tokenObj = Accounts.emailToken._hashToken(token);                                                        // 135
  tokenObj.createdAt = new Date();                                                                             // 136
                                                                                                               // 137
  if (user) {                                                                                                  // 138
    var identity = user.identities[0];                                                                         // 139
    if (identity.service.emailToken.tokens && identity.service.emailToken.tokens.length > 2) {                 // 140
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " +           // 141
        "ago. Please use the one that was already sent (check your spam folder if you can't find " +           // 142
        "it), or wait a while and try again");                                                                 // 143
    }                                                                                                          // 144
    userId = user._id;                                                                                         // 145
                                                                                                               // 146
    Meteor.users.update({"identities.id": identityId},                                                         // 147
                        {$push: {"identities.$.service.emailToken.tokens": tokenObj}});                        // 148
  } else {                                                                                                     // 149
    var options = {                                                                                            // 150
      service: {emailToken: {email: email, tokens: [tokenObj]}},                                               // 151
    };                                                                                                         // 152
                                                                                                               // 153
    userId = Accounts.insertUserDoc(options, {});                                                              // 154
  }                                                                                                            // 155
                                                                                                               // 156
  sendTokenEmail(email, token);                                                                                // 157
                                                                                                               // 158
  return userId;                                                                                               // 159
};                                                                                                             // 160
                                                                                                               // 161
// method for create user. Requests come from the client.                                                      // 162
// This method will create a user if it doesn't exist, otherwise it will generate a token.                     // 163
// It will always send an email to the user                                                                    // 164
Meteor.methods({createAndEmailTokenForUser: function (email) {                                                 // 165
  check(email, String);                                                                                        // 166
                                                                                                               // 167
  if (!Accounts.emailToken.isEnabled()) {                                                                      // 168
    throw new Meteor.Error(403, "Email Token service is disabled.");                                           // 169
  }                                                                                                            // 170
  // Create user. result contains id and token.                                                                // 171
  var user = createAndEmailTokenForUser(email);                                                                // 172
}});                                                                                                           // 173
                                                                                                               // 174
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-email-token'] = {};

})();

//# sourceMappingURL=accounts-email-token.js.map
